****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 3020001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--L16
'
'###############################################################
'#                        ADWL16.inc                           #
'#              INCLUDE-file for ADwin-Light 16                #
'###############################################################
'#                                                             #
'# Contents: Include functions for ADwin-Light 16              #
'#                                                             #
'#  13.06.2002  MF   creation                                  #
'#  14.08.2002  JK   cntnr   ->  (cntnr)                       #
'#                                                             #
'# 		Attention:                                               #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'###############################################################

#define  enadrwr  204000dch      'wr 13            Address-table to access the hardware 
#define  enadrrd  204001dch      'wr 29
#define  rdcan    204000fch      'rd 15
#define  wrcan    204000fch      'wr 15
#define  rescan   204001fch      'rd 14

dim can_msg[9] as integer   			' array with 9 elements 


'***************************************************************
'***************** DIO on Light 16 extension *******************
'***************************************************************

'***************************************************************
' Initialisation of digital I/O   
' value : each bit corresponds to 8 bit
'     0 = input
'     1 = output
'***************************************************************
SUB CONF_DIO_E(value)
	Poke(2040046CH,value)
ENDSUB


'***************************************************************
' Reads the digital inputs (channel 0 - 15) 
'***************************************************************
FUNCTION DIGIN_WORD1_E() as long
  DIGIN_WORD1_E=peek(20400454H)
ENDFUNCTION


'***************************************************************
' Reads the digital inputs (channel 16 - 31) 
'***************************************************************
FUNCTION DIGIN_WORD2_E() as long
  DIGIN_WORD2_E=peek(20400464H)
ENDFUNCTION

'***************************************************************
' Sets the digital outputs (channel 0 - 15) 
'***************************************************************
SUB DIGOUT_WORD1_E(value)
	Poke(20400454H,value)
ENDSUB


'***************************************************************
' Sets the digital outputs (channel 16 - 31) 
'***************************************************************
SUB DIGOUT_WORD2_E(value)
	Poke(20400464H,value)
ENDSUB


'***************************************************************
' Sets selected digital outputs (channel 0-15)
' set : Bitstring indicating the outputs which should be set
'***************************************************************
SUB DIGOUT_SET1_E(set)   'Set Register Bit 0-15
	Poke(20400474H,set)
ENDSUB


'***************************************************************
' Sets selected digital outputs (channel 16-31)
' set  : Bitstring indicating the outputs which should be set
'***************************************************************
SUB DIGOUT_SET2_E(set)   'Set Register Bit 16-31
	Poke(20400484H,set)
ENDSUB


'***************************************************************
' Resets selected digital outputs (channel 0-15)
' reset: Bitstring indicating the outputs which should be reset
'***************************************************************
SUB DIGOUT_RESET1_E(reset) 'Reset Register Bit 0-15
	Poke(20400494H,reset)
ENDSUB


'***************************************************************
' Resets selected digital outputs (channel 16-32)
' reset: Bitstring indicating the outputs which should be reset
'***************************************************************
SUB DIGOUT_RESET2_E(reset) 'Reset Register Bit 16 - 31
	Poke(204004A4H,reset)
ENDSUB



'***************************************************************
'************************ Counter ******************************
'***************************************************************

'***************************************************************
SUB CNT_CLEAR(CNTSELECT) 
' clear all counters selected with a bit 1
poke(20400310h,CNTSELECT)
ENDSUB

' **************************************************************
SUB CNT_ENABLE(CNTSELECT) 
' enable all counters selected with a bit 1
poke(20400300h,CNTSELECT)
ENDSUB

' **************************************************************
SUB CNT_MODE(CNTSELECT) 
' Select Counter-mode  (0 = CLK external, 1 = CLK internal(PWM))
poke(20400340h,CNTSELECT)
ENDSUB

' **************************************************************
SUB CNT_SET(CNTSELECT) 
' Set Counter   (0 = 4fach, 1 = CLK/DIR)
' Set PWM-Counter Frequency (0 = 20 MHz, 1 = 5 MHz)
poke(20400350h,CNTSELECT)
ENDSUB

' **************************************************************
SUB CNT_INPUTMODE(CNTSELECT) 
' Set Counterinputline   (0 = Clear counter, 1 = latch counter)
poke(20400330h,CNTSELECT)
ENDSUB

' **************************************************************
SUB CNT_LATCH(CNTSELECT) 
' latch all counters selected with a Bit 1
poke(20400320h,cntselect)
ENDSUB

' **************************************************************
FUNCTION CNT_READ(CNTNR) AS long
' performs a software-latch and reads the selected counter
' ATTENTION : this function may NOT be used, if the latch is
'  done by an external signal (e.g. period-time or pulse 
'  low/high-time measurements) !

   dim cadr as integer
   dim cntsel as integer

   cntsel = shift_left(1,(cntnr-1))
   poke(20400320h, cntsel)
   cadr = 204001F4h + (cntnr) * 16 ' parentheses bec.  i + 1 
                                   ' could be passed as cntnr 
   cnt_read = peek(cadr)
   ' (we do not need multiple reads, because for software
   '  latch the synchronisation is done by hardware.)    

ENDFUNCTION

' **************************************************************
FUNCTION CNT_READLATCH(CNTNR) AS long
' reads the latch register triggerd by software-latch or 
'  signal-rise (of an external signal)

   dim cadr as integer
   dim ih as integer

   cadr = 204001F4h + (cntnr) * 16 ' parentheses bec.  i + 1 
                                   ' could be passed as cntnr 
   cnt_readlatch = peek(cadr)

 ' case a : the latch register is triggered by a software- latch :
 ' ---------------------------------------------------------------
 ' In this case, there is no need for multiple reads, because 
 '  the synchronisation is done by hardware (see also the 
 '  comments at CNT_READ()). The following instructions are 
 '  not necessary, but they also do not harm (except wasting
 '  time). Therefore they are a potential for speed optimi-
 '  sations.

 ' case b : the latch register is triggered by an external signal :
 ' ----------------------------------------------------------------
 ' Check, if there was a (from an external signal triggered)
 '  LATCH just in the moment, when we read in the latch 
 '  register. (This is neccessary because this case is not
 '  handled by the hardware.)
 '  If we have this case, the second reading of the latch 
 '  register differs from the first reading and therefore 
 '  one of the readings may be corrupt. Read a third time to 
 '  be sure to have a valid reading. 
 '        The measured time for these three readings is 25 
 '        cycles = 625 ns   => the (period) time between two
 '        successive (external signal triggered) LATCHs may 
 '        NOT be shorter than this limit.
 '        => valid measurements (using this method with LATCH
 '        done by external signal) cannot be guaranteed for 
 '        smaller LATCH (period) times than 625 ns. (Longtime 
 '        tests were done and o.k. with 664 ns). To have a  
 '        safety margin for future changes in the ADbasic  
 '        compiler, our statement to the customer is the  
 '        limit of 1000 ns. 

   ih = peek(cadr)
   if (ih <> cnt_readlatch) then
     cnt_readlatch = peek(cadr)
   endif
ENDFUNCTION


'***************************************************************
FUNCTION CNT_READFLATCH(CNTNR) AS long
' reads the latch register triggerd by signal-falling edge

   dim cadr as integer
   dim ih as integer
   
   cadr = 204001F8h + (cntnr) * 16 ' parentheses bec.  i + 1 
                                   ' could be passed as cntnr 
   cnt_readflatch = peek(cadr)
   ' (please see comments to READLATCH)
   ih = peek(cadr)
   if (ih <> cnt_readflatch) then
      cnt_readflatch = peek(cadr)
   endif
ENDFUNCTION


'***************************************************************
' reads the status of a counter input 
'***************************************************************
FUNCTION CNT_GETSTATUS() AS long
 CNT_GETSTATUS = PEEK(20400370h)           
ENDFUNCTION


'***************************************************************
' enables the hardware clear input of a counter
' value : bitcombination ; each bit corresponds with counter
'***************************************************************
SUB CNT_CLEARENABLE(value) 
 dim value2 as long
 value2=value AND 0FH
 Poke(20400370H,value2)
endsub


'***************************************************************
'***************************** CAN *****************************
'***************************************************************
'Enables a message object for receiving messages.
'Disables all interrups of the message object.
'objectnumber : Number of the message object
'Identifier : incomming frames are accepted by this message object, if the identifier matches the frame identifier
'extended: Determines whether the identifier is 11 or 29 Bit
'	     0 = 11 Bit Identifier 	
'	     1 = 29 Bit Identifier 	
'***************************************************************

sub en_receive(objectnumber,identifier,extended)
    set_can_reg(objectnumber * 16, 149)
    if (extended = 0) then 
      set_can_reg(objectnumber * 16 + 6, 128)													'read; DLC = 8 ; 11 Bit Identifier
      set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,3)and 255))  'Set Identifier
      set_can_reg(objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
    else
      set_can_reg(objectnumber * 16 + 6, 132)													'read; DLC = 8 ; 29 Bit Identifier
      set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,21)and 255))	'Set Identifier
      set_can_reg(objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
      set_can_reg(objectnumber * 16 + 4, (shift_right(identifier,5)and 255))  
      set_can_reg(objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
    endif
endsub



'***************************************************************
'Enables a message object for transmitting messages.
'Disables all interrups of the message object.
'objectnumber : Number of the message object
'Identifier : identifier for the frames which will be transmitted
'extended: Determines whether the identifier is 11 or 29 Bit 
'	     0 = 11 Bit Identifier 	
'	     1 = 29 Bit Identifier 	
'***************************************************************

sub en_transmit(objectnumber,identifier,extended)
  REM Message Objekt freigeben
    set_can_reg(objectnumber * 16, 149)
    if (extended = 0) then 
      set_can_reg(objectnumber * 16 + 6, 136)													'write; DLC = 8 ; 11 Bit Identifier
      set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,3)and 255))	'Set Identifier
      set_can_reg(objectnumber * 16 + 3, (shift_left(identifier,5)and 255))
    else
      set_can_reg(objectnumber * 16 + 6, 140)													'write; DLC = 8 ; 29 Bit Identifier
      set_can_reg(objectnumber * 16 + 2, (shift_right(identifier,21)and 255))	'Set Identifier
      set_can_reg(objectnumber * 16 + 3, (shift_right(identifier,13)and 255))
      set_can_reg(objectnumber * 16 + 4, (shift_right(identifier,5)and 255))	
      set_can_reg(objectnumber * 16 + 5, (shift_left(identifier,3)and 255))
    endif
endsub


'***************************************************************
'Initialisation of the CAN-controller.
'All message objects will be disabled.
'Bitrat: 1MBit/s
'Acceptance filter : Must match
'***************************************************************

sub init_can()
dim count as integer

  poke(rescan,1)					' Reset the CAN-Controllers (Hardwarereset)
  sleep(10000)						'Resetpin mu mindestens 1 ms low sein
  poke(rescan,0)

  set_can_reg(0,65)       'Access to the registers of the controller only for CPU

    set_can_reg(2,65)     'CPU interface register

    set_can_reg(06h,0ffh) 'Setting all masks to "must match"
    set_can_reg(07h,0ffh)
    set_can_reg(08h,0ffh)
    set_can_reg(09h,0ffh)
    set_can_reg(0ah,0ffh)
    set_can_reg(0bh,0ffh)
    set_can_reg(0ch,0ffh)
    set_can_reg(0dh,0ffh)
    set_can_reg(0eh,0ffh)
    set_can_reg(0fh,0ffh)

    set_can_reg(01fh,0)     'Clock Out Register
 
    set_can_reg(02fh,0)     'Bus configuration register

    set_can_reg(03fh,0)     'Bit Timing register 0  

    set_can_reg(04fh,32)		' Bit Timing register 1 

  for count = 1 to 15				'Disable all message objects
    set_can_reg(count * 16,85)
    set_can_reg(count * 16 + 1,85)
  next count 

  set_can_reg(0,0)				  'Access to the registers of the controller only for Application 
endsub


'***************************************************************
'Function only for internal use.
'***************************************************************
function round_intern(value) as long
dim buffer as float
  buffer = value + 0.5
  round_intern = buffer
endfunction

'***************************************************************
'Function only for internal use.
'***************************************************************
function int_check(fl,int) as long
dim fbuffer as float
  fbuffer = fl-int
  if ((fbuffer >= 0.00001) or (fbuffer <= -0.00001)) then 
    int_check = 1				'not equal
  else
    int_check = 0				'equal
  endif
endfunction

'***************************************************************
'Function is setting the baudrate of the CAN-Bus.
'rate : CAN-Bus baudrate
'return value : 0 = baudrate is set 
'		    1 = the selected baudrate is not set 
'***************************************************************

function set_can_baudrate(rate) as long
dim scale as long
dim fbuffer as float
dim lbuffer as long
dim back as long
dim tseg1 as long  
dim tseg2 as long  
dim brp as long  
dim btr0 as long  
dim btr1 as long  
  set_can_baudrate = 0					'Initialisation
  fbuffer = 8000000 / rate
  scale = round_intern(fbuffer)				'total scale to achive the baudrate
  set_can_baudrate = int_check(fbuffer,scale)	'1 if baudrate not possible

  if (set_can_baudrate = 0) then			'If baudrate possible then find settings
    brp = (scale - 1) / 25				'Prescaler

    do 							'find the right brp
      fbuffer = (scale / (brp + 1) - 3)
      lbuffer = round_intern(fbuffer)
      back = int_check(fbuffer,lbuffer)		'inc prescaler until tseg1 + tseg 2 is an integer
      inc(brp)
    until((back = 0) or (fbuffer<5)) 
    dec(brp)
    if (back <> 0) then set_can_baudrate = 1
  endif

  if (set_can_baudrate = 0) then			'If there is a correct prescaler
    tseg2 = lbuffer * 0.4
    tseg1 = lbuffer - tseg2
    if (tseg2 > 7) then
      do
        dec(tseg2)
        inc(tseg1)
      until(tseg2 = 7)
    endif 
    btr0 = brp						'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + shift_left(tseg2,4)		'one sampling each Bit
    set_can_reg(0,65) 			'enable access to btr regisers
    set_can_reg(3fh,btr0)		'set btr0 regisers
    set_can_reg(4fh,btr1)		'set btr1 regisers
    set_can_reg(0,0) 			  'disable access to btr regisers
  endif
endfunction




'***************************************************************
'The function checks, if there is a new frame in the selected
'message object. If there is a new frame all databytes are read
'and then written to the array "can_msg".
'The number of dadabytes is written to the element 9 of the array "can_msg".
'The return value of the function is the identifier of the frame. 
'If there is no new frame in the message box the return value is -1.
'msg_nummer : number of the message object
'***************************************************************


function read_msg(msg_nummer) as integer
  dim new as integer                                           ' new message in the message object
  dim id0,id1,id2,id3 as integer                               ' Identifier Byte 0 und 1
  dim count as integer                                          
  dim buffer as integer							   
  dim id_lenght as integer						 												 ' buffer to distinguish 11 and 29 bit identifier

  new = get_can_reg(msg_nummer * 16 + 1) and 3                 'New Data Bit (check for new message)

  if (new =2) then                                             ' New frame is arrived

    buffer = get_can_reg(msg_nummer * 16 + 6)
    can_msg[9] = shift_right((buffer and 0f0h),4)              'nomber of data bytes
    id_lenght = buffer and 4

    id0 = get_can_reg(msg_nummer * 16 + 2)				             'Identifierbyte 0
    id1 = get_can_reg(msg_nummer * 16 + 3)				             'Identifierbyte 1
    if (id_lenght = 4) then
      id2 = get_can_reg(msg_nummer * 16 + 4)				           'Identifierbyte 2
      id3 = get_can_reg(msg_nummer * 16 + 5)				           'Identifierbyte 3
    endif

    for count = 1 to can_msg[9]                                ' reading databytes
      can_msg[count] = get_can_reg((msg_nummer * 16) +count+6)
    next count

    set_can_reg(msg_nummer * 16,0fdh)                     ' Reset the new data flag
    set_can_reg(msg_nummer * 16 +1,85) 
    if (id_lenght = 0) then
      read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' return value = 11 bit identifier
    else
      read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13))  or (shift_left(id0,21))       ' return value = 29 bit identifier
    endif
  else
    read_msg = -1                                                  ' return value = -1
  endif
endfunction



'***************************************************************
'Transmitting a frame. 
'msg_nummer : number of the message object
'The databytes and the number of databytes have to be written in the
'array "can_msg" before this subroutine is activated.
'After this subroutine the frame is transmitted as soon as the 
'CAN-bus allows it.
'***************************************************************

sub transmit(msg_num)
dim buffer as integer
dim count as integer

  for count = 1 to can_msg[9]
    set_can_reg((msg_num * 10h)+count+6,can_msg[count]) 'copy datas
  next count

  REM transfer nomber of data bytes
  buffer = get_can_reg((msg_num * 10h)+6)         'read register
  buffer = buffer and 0fh                         ' change DLC Bits 
  buffer = buffer or shift_left(can_msg[9],4)
  set_can_reg(msg_num *16 +6,buffer)           ' write register
  
  set_can_reg(msg_num * 16 +1, 102)' Control register (setting bit to transmit data)
ENDSUB

'***************************************************************
'Enable the interrupt of a message object.
'msg_nummer : number of the message object
'***************************************************************
sub en_interrupt(msg_num)
  set_can_reg(msg_num * 16, 0ebh)
  set_can_reg(0, 02h)
endsub



'***************************************************************
'Setting a register of the CAN-controller.
'register_no : register which should be set
'value : value which should be written to the register.
'***************************************************************

sub set_can_reg(registernummer, wert)   
    #IF PRIORITAET = LOW						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
      BEGIN_CRITICAL_SECTION
    #ENDIF
  poke(enadrwr,registernummer) 
  poke(rdcan,wert) 
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
endsub



'***************************************************************
'Reading a register of the CAN-controller.
'register_no : register to read
'return value : value of the register
'***************************************************************

Function get_can_reg(registernummer) as integer
    #IF PRIORITAET = LOW						'It is not allowed to interrupt the process while accessing an ADwin-Pro module. This part disables the interrupt.
      BEGIN_CRITICAL_SECTION
    #ENDIF
  poke(enadrrd, registernummer) 
  sleep(6)
  get_can_reg = peek(rdcan)
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
endfunction
'***************************************************************


