#ifndef CONFIG_FILE_H
#define CONFIG_FILE_H

#include <linux/adwin.h>

// this config file code is used if ONLY ethernet is enabled
// and if we don't use the kernel module facility

// this is ugly: globally declared, and MAX_DEVICESx104 bytes large
// todo: dynamic allocation with linked list
extern adwin_dev_t device_list[MAX_DEVICES];
// number of configured devices / number of valid entries in device_list
extern int configured_devices;

int findDevice(int device);
void clearDevice(adwin_dev_t *dev);
void addDeviceCF(adwin_dev_t dev);
void deleteDeviceCF(int device);
void reloadConfigFile();
void printDeviceConfig(FILE *fd, adwin_dev_t dev);
void printConfig(FILE *fd);
int existsConfigFile();
int getAdwindir(char *adwindir);

#endif // CONFIG_FILE_H
