//***********************************************************************************************
// This file is included in libadwin.c
// DLL-Funktionen Definition simulation(The AD.. functions are special for LABview) +************
// The functions are just a wrapper, which is calling the linux functions adwin_.. .
//
//***********************************************************************************************

long ADboot(const char *Dateiname, short Linkadresse, long iboardsize, short msgbox)
{
    Set_DeviceNo (Linkadresse);
    return adwin_boot(Dateiname, iboardsize, Linkadresse);
}


long ADGetErrorCode(void) {
	int tmp_errno;

	tmp_errno=adwin_errno;
	adwin_errno=0;  //damit es kompatibel zu Windows-DLL ist;
	return tmp_errno;
}


long ADGetErrorText(long ErrCode, char *pText, long len) {
	strncpy(pText, adwin_strerror(ErrCode), len);
    return 0;
}

 short ADBload(const char *dateiname,short Linkaddresse,short msgbox){  //Load_Process
    Set_DeviceNo (Linkaddresse);
    return adwin_process_load(dateiname, Linkaddresse);
}

 short ADB_Start (short np, short nadr){  //Start_process
    Set_DeviceNo (nadr);
    return adwin_process_start(np, nadr);
 }

 extern short Start(short np, short nadr){  //Start von Standardprozessen
     adwin_errno=k_function_not_allowed;
     return 255;
}

 extern short Stop(short np, short nadr){  //Stop von Standardprozessen
     adwin_errno=k_function_not_allowed;
     return 255;
}

extern short Get_List(short *tarr, short typ, short nadc, short proc, long il, short nadr){
      // Standardprozesse werden nicht untersttzt
     adwin_errno=k_function_not_allowed;
     return 255;
}

extern short Set_List(short *tarr, short typ, short nadc, long il, short nadr){
     // Standardprozesse werden nicht untersttzt
     adwin_errno=k_function_not_allowed;
     return 255;
}

 short ADB_Stop (short np, short nadr){  // Stop_Process
    Set_DeviceNo (nadr);
    return adwin_process_stop(np, nadr);
 }

 short ADSetLanguage(short Lang){
    adwin_errno=k_function_not_allowed;
    return 255;
 }

 short Set_ADBPar (short np, long iw, short nadr){  // Set_Par
    Set_DeviceNo (nadr);
    return adwin_set_par(np, iw, nadr);
 }
 short Set_ADBFPar(short np, float fw, short nadr){ // Set_FPar
    Set_DeviceNo (nadr);
    return adwin_set_fpar(np, fw, nadr);
 }
 long Get_ADBPar (short np, short nadr){  //Get_Par
    Set_DeviceNo (nadr);
    return adwin_get_par(np, nadr);
 }
 float Get_ADBFPar(short np,short nadr){ // Get_FPar
    Set_DeviceNo (nadr);
    return adwin_get_fpar(np, nadr);
 }
 short Get_Data(void *tarr,short typ, short nadc, long lstart, long il ,short nadr){
 	/*  typ = 2 fr long
	  typ = 5 fr float
	  typ = 6 fr double */

     Set_DeviceNo (nadr);
     switch (typ)
     {
     	case 2:  //long
	{
	   return adwin_get_data_int32(nadc, lstart, il, (int32_t*) tarr, nadr);
	   break;
	}
	case 5:  //float
	{
	   return adwin_get_data_float (nadc, lstart, il, (float*) tarr, nadr);
	   break;
	}
	case 6:  //double
	{
	   return adwin_get_data_double(nadc, lstart, il, (double*) tarr, nadr);
	   break;
	}

	default :
	{
            adwin_errno=k_function_not_allowed;
	    return 255;
	}

     }


}

 short Set_Data(void *tarr,short typ, short nadc, long lstart, long il ,short nadr){
 	/*  typ = 2 fr long
	  typ = 5 fr float
	  typ = 6 fr double */
     Set_DeviceNo (nadr);
     switch (typ)
     {
     	case 2:  //long
	{
	   return adwin_set_data_int32(nadc, lstart, il, (int32_t*) tarr, nadr) ;
	   break;
	}
	case 5:  //float
	{
	   return adwin_set_data_float(nadc, lstart, il, (float*) tarr, nadr) ;
	   break;
	}
	case 6:  //double
	{
	   return adwin_set_data_double(nadc, lstart, il, (double*) tarr, nadr) ;
	   break;
	}

	default :
	{
            adwin_errno=k_function_not_allowed;
	    return 255;
	}

     }
 }

short SaveFast(const char *dateiname,short Datanr,long startindex,long anzahldaten,short anhaengen,short linkaddresse){  // Data2File
   Set_DeviceNo (linkaddresse);
   return adwin_data2file((char *) dateiname, Datanr, startindex, anzahldaten, anhaengen, linkaddresse);
}
short Get_Fifo (void *tarr,short typ, short nadc, long il ,short nadr){
	/*  typ = 2 fr long
	  typ = 5 fr float
	  typ = 6 fr double */
     Set_DeviceNo (nadr);
     switch (typ)
     {
     	case 2:  //long
	{
	   return adwin_get_fifo_int32(nadc, il, (int32_t*) tarr, nadr);
	   break;
	}
	case 5:  //float
	{
	   return adwin_get_fifo_float(nadc, il, (float*) tarr, nadr);
	   break;
	}
	case 6:  //double
	{
	   return adwin_get_fifo_double(nadc, il, (double*) tarr, nadr);
	   break;
	}

	default :
	{
            adwin_errno=k_function_not_allowed;
	    return 255;
	}

     }
}
short Set_Fifo (void *tarr,short typ, short nadc, long il ,short nadr){
	/*  typ = 2 fr long
	  typ = 5 fr float
	  typ = 6 fr double */

     Set_DeviceNo (nadr);
     switch (typ)
     {
     	case 2:  //long
	{
	   return adwin_set_fifo_int32(nadc, il, (int32_t*) tarr, nadr);
	   break;
	}
	case 5:  //float
	{
	   return adwin_set_fifo_float(nadc, il, (float*) tarr, nadr);
	   break;
	}
	case 6:  //double
	{
	   return adwin_set_fifo_double(nadc, il, (double*) tarr, nadr);
	   break;
	}

	default :
	{
            adwin_errno=k_function_not_allowed;
	    return 255;
	}

     }
}
long Get_Fifo_Count (short nadc, short nadr ){  // Fifo_Full
   Set_DeviceNo (nadr);
   return adwin_fifo_full(nadc, nadr);
}
long Get_Fifo_Empty (short nadc, short nadr ){  // Fifo_Empty
   Set_DeviceNo (nadr);
   return adwin_fifo_empty(nadc,nadr);
}
short Clear_Fifo (short nadc, short nadr ){  //Fifo_Clear
   Set_DeviceNo (nadr);
   return adwin_fifo_clear(nadc, nadr);
}


unsigned short Get_ADC (short nadc, short nadr){ //ADC
  adwin_errno=k_function_not_allowed;
  return 255;
}
short Set_DAC (short ndac, short iw, short nadr){  //SetDAC
  adwin_errno=k_function_not_allowed;
  return 255;
}

long Get_Digin (short nadr){  //DigIn
  adwin_errno=k_function_not_allowed;
  return 255;
}
short Set_Digout (short iw, short nadr){  //SetDigOut
  adwin_errno=k_function_not_allowed;
  return 255;
}
long Get_Digout (short nadr){
  adwin_errno=k_function_not_allowed;
  return 255;
}
short AD_Workload (long Priority, short Linkaddresse){  //Workload
  Set_DeviceNo (Linkaddresse);
  return adwin_workload(Linkaddresse);
}
short ADTest_Version (short Linkaddresse,short msgbox){  // Test_Version
  int tmp_ret;
  Set_DeviceNo (Linkaddresse);
  tmp_ret=adwin_test_version(Linkaddresse);
  if (tmp_ret!=0) return 3;
  else return 0;
}
long AD_Memory_all (short typ,short Linkaddresse){  // Free_Mem
  Set_DeviceNo (Linkaddresse);
  return adwin_mem(typ, Linkaddresse);
}

long AD_Memory(short Linkaddresse){
   adwin_errno=k_function_not_allowed;
   return 255;
}


// ADNet_Connect und / Disconnect bleibt draussen laut SJ am 8.5.03
short ADProzessorTyp (short Linkaddresse){
  Set_DeviceNo (Linkaddresse);
  return adwin_processor_type(Linkaddresse);
}
/*Wurde wegen Namenkonflikt entfernt, muss aus LabView zustzlich entfernt werden
long Clear_Process (short proc_nr , short nadr){
  return adwin_process_clear(proc_nr, nadr);
}
*/
short Get_ADBPar_All (short np,short anzahl,long *pData, short nadr){ //Get_Par_Block
  Set_DeviceNo (nadr);
  return adwin_get_par_block(np, anzahl, (int32_t *) pData, nadr);
}
short Get_ADBFPar_All (short np,short anzahl,float *pData,short nadr){ //Get_FPar_Block
  Set_DeviceNo (nadr);
  return adwin_get_fpar_block(np, anzahl, pData, nadr);
}
long GetDataLength (short nr,short nadr){
  Set_DeviceNo (nadr);
  return adwin_data_length(nr, nadr);
}


/* vorerst nicht:
short Get_Known_DeviceNo(long *Devices, long Count_Devices);
DLL: short Get_Known_Deviceno(short *devices, long *count_devices);

long Get_Known_USB_SerialNo(long *SerialNo);
DLL: long Get_Known_USB_SerialNo(long *serialno);

int AD_Debug_On(BSTR * Filename, long Size);
DLL: int adwin_debug_mode_on(const char *dateiname, long size);

void AD_Debug_Off();
DLL: int adwin_debug_mode_off();
*/


long Get_Data_String (char *Data, long MaxCount,short DataNo, short nadr){
Set_DeviceNo (nadr);
return adwin_get_data_string(DataNo, MaxCount, Data, nadr);
}
long Get_Data_String_Length(long DataNo, short nadr){
Set_DeviceNo (nadr);
return adwin_strlen(DataNo, nadr);
}
long Set_Data_String(const char *Data, short DataNo, short nadr){
Set_DeviceNo (nadr);
return adwin_set_data_string(DataNo, Data, nadr);
}
