****************************************
*	 Prozenummer = 1
*	 Delay = 1953
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
' file : FFT_scale_demo.BAS			
' 990714 JK  created
' 020322 JK  IMPORT FFT.LI9
' 040130 JK  updated for T10 processor
' for all ADwin-systems with T9 or T10 processor
'--------------------------------------------------------------------------

' This program generates internally a frequency of 60 Hz with the amplitude
' of 0.7 (unitless). Upon this frequency a frequency of 30 Hz with 
' amplitude 1.0 and a constant offset of 1.5 is superposed. After the calls
' of the funktions FFT(), FFT_mag() and FFT_scale() we get a spectrum, 
' where the amplitudes of the showed frequencies match exactly to the 
' magnitudes of the signal components in the original waveform  : 
'			DATA_6[7]   = 1                        (60 Hz)
'			DATA_6[4]   = 0.7                      (30 Hz)
'			DATA_6[1]   = 1.5                      (constant offset)
'			DATA_6[all other elements]   = 0


#IF PROZESSOR = T10 THEN
IMPORT FFT.LIA
#ELSE
IMPORT FFT.LI9
#ENDIF

#DEFINE PI 		3.141592654 

DIM DATA_1[1024], DATA_3[4096], DATA_5[512]  AS FLOAT AT DM_LOCAL
DIM DATA_2[1024], DATA_4[4096], DATA_6[512]  AS FLOAT AT DM_LOCAL
DIM help_1[4096], help_2[4096]               AS FLOAT AT DM_LOCAL
DIM run, number                  AS LONG
DIM sim_freq1, sim_freq2, T_total, sample_freq AS FLOAT   
DIM const_offset   AS FLOAT ' (maybe a DC- offset)

LOWINIT:
  number = 1024   ' number of points for FFT (must be a power of 2)
  T_total = 0.1   ' [s]  total sampling time  
  sample_freq = number / T_total ' [Hz] ( = 10240 Hz)
  '	25 ns is the unit of ADSP system timer for a high priority process
  GLOBALDELAY = 1000000000 * T_total / number / 25

  sim_freq1 = 60     ' [Hz]     internal frequency generator 1
  sim_freq2 = 30     ' [Hz]     internal frequency generator 2
  const_offset = 1.5  ' [unitless]

  run = 1
EVENT:
  DATA_1[run] = 0.7 * sin(2*PI * sim_freq1 * T_total * run / number) 
  DATA_1[run] = DATA_1[run]+sin(2*PI * sim_freq2 * T_total * run/number) 
  DATA_1[run] = DATA_1[run] + const_offset
  DATA_2[run] = 0     '  clear the array with imaginary rate of data

  IF (run = number) THEN	END
  run = run + 1
	
FINISH:
  FFT(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number)
  FFT_mag(DATA_3, DATA_4, DATA_5, number / 2) ' magnitude into DATA_5
  FFT_scale(DATA_5, DATA_6, number / 2) ' scaled magnitude into DATA_6
