****************************************
*	 Prozenummer = 2
*	 Delay = 4000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 0
*	 SAVECOMPIL = 0
****************************************
'##########################################################################
'# The process BAS_DMO7.BAS is a waveform generator for ADwin-Gold and
'# ADwin-L16 systems. Prior to start the generator the waveform can be
'# stored into DATA_2[]. Alternatively a default waveform can be generat-
'# ed by this program internally.
'# The frequency does not have to be an integer value and can be set very 
'# accurately (i.e. 0.987 Hz is possible). This program has intentionally 
'# the process number 2. Therefore it can be executed simultaneously with
'# the programs BAS_DMO1.BAS, BAS_DMO3.BAS and BAS_DMO4.BAS.
'#
'# FPAR_1 : frequency [Hz]
'# PAR_7  : amplitude (0 = 0 Volts, 32767 ~ 10 Volts)
'# PAR_8  : If=0 then a default waveform (sine wave)
'#            is generated internally
'#          If<>0 then the waveform has to be loaded
'#            by the application program
'##########################################################################

#DEFINE pi2 6.28318531        ' 2 * 3.14159265

DIM DATA_2[10001] AS FLOAT		'waveform table (length=1+1/(cycle time [s]))
DIM count AS FLOAT
DIM i AS LONG

LOWINIT:
  GLOBALDELAY = 4000									'cycle-time of 0.1ms
  IF (PAR_8 = 0) THEN 
    FOR i = 1 TO 10000
      DATA_2[i] = sin(pi2 * i / 10000) 'generates a sine wave
    NEXT i
    DATA_2[10001] = DATA_2[1] 				'one additional element is necessary !
  ENDIF
  count = 0
  DAC(1,32768)											'0 Volt output

EVENT:
  count = count + FPAR_1 						'freq. is used for incr. the array index
  IF (count > 1E4) THEN count = count - 1E4		'check for turn-around
	i = count + 1											'the first valid array index is 1
  DAC(1,DATA_2[i] * PAR_7 + 32768)	'calculate output value
	
FINISH:
  DAC(1,32768)											'0 Volt output
